#!/usr/bin/perl
#print this MIME data no matter what
print "Content-type: text/html\n\n";
#flush stdout buffer
$| = 1;

&parse_form_data (*data);

#Calculations
use Table;

$loc_data_table = "features";
$scid = $data{'scid'};
$scid =~ s/^\s*(.*?)\s*$/$1/;        #get rid of bordering white space
$scid = uc($scid);


$scid =~ s/-//g;  #remove any hyphens from scid

$opt = $data{'opt'};

#first see if the id format is correct

foreach (T_LoadRows ($loc_data_table)) {
  if ($_->{"scid_"} eq $scid) {
    ($cdc28) = T_GetFields($_,"cdc28");
    ($masageg,$masagel,$masages,$mayoung,$ch_a,$ch_alpha,$ch_gal,$ch_heat,$samson,$mrcyc15,$mrcyc28,$mrcycsd,$mrcyelu,$mrdiasd,$cdc28,$ckii,$coildco,$farn,$ggsi,$glyc,$hdel,$knocout,$length,$mit1,$mit2,$myri,$nuc1,$nuc2,$pi,$pka,$plmnew1,$pox1,$rostall,$sig1,$signalp,$tms1,$ref_mrna_expr,$ref_prot_expr) = T_GetFields($_,"sage-gm_phase","sage-l_phase","sage-s_phase","young","church-a","church-alpha","church-gal","church-heat","samson","std-cdc15","std-cdc28","std-alpha","std-elu","std-diauxic","cdc28","ckii","coildco","farn","ggsi","glyc","hdel","knockout","length","mit1","mit2","myri","nuc1","nuc2","pi","pka","plmnew1","pox1","rostall","sig1","signalp","tms1","ref_mrna_expr","ref_prot_expr");
    last;
  }
}

if (not defined $cdc28){                          #ORF not found
  print "<html><body>The ORF you specified does not exist.";
  exit(1);
}

if ($knocout == 1) {$knocout = "lethal";} else {$knocout = "viable";}

###############################################################################
#CGI Output
#Create html document
print <<HTML;
<html>

<head>
<title>ORF Features</title>
<style type="text/css">
td.grey {background: lightgrey}
th {background: lightgrey}
td.cap {background: mediumblue; color: white; font-weight: bold; font-size: 125%}
td.back {background: white}
</style>
</head>

HTML


my $hvar = `perl /web/genecensus/header/header.cgi features`; print $hvar;


print <<HTML;

<h2>Features for $scid </h2>

<table border="0" cellspacing=2>

<tr valign=top><td class="back">

<dd><table border="0" cellspacing=3 cellpadding=0>
<tr><td class="cap" colspan=2>Absolute Expression Data</td></tr>
<tr><td class="grey"><b>Feature</b><td class="grey"><b>Value</b>
<tr><td class="grey">Reference mRNA Expression (copies/cell) <td class="grey">$ref_mrna_expr
<tr><td class="grey">Reference Protein Expression (10^3 copies/cell) <td class="grey">$ref_prot_expr
<tr><td class="grey">Young mRNA Expression <font size=-2><a target=_blank href="features_help.html#mayoung">[Help]</a></font> <td class="grey">$mayoung
<tr><td class="grey">SAGE mRNA Expression (g/m phase) <font size=-2><a target=_blank href="features_help.html#masageg">[Help]</a></font> <td class="grey">$masageg
<tr><td class="grey">SAGE mRNA Expression (l phase) <font size=-2><a target=_blank href="features_help.html#masagel">[Help]</a></font> <td class="grey">$masagel
<tr><td class="grey">SAGE mRNA Expression (s phase) <font size=-2><a target=_blank href="features_help.html#masages">[Help]</a></font> <td class="grey">$masages
<tr><td class="grey">Church mRNA Expression (a) <font size=-2><a target=_blank href="features_help.html#ch_a">[Help]</a></font> <td class="grey">$ch_a
<tr><td class="grey">Church mRNA Expression (alpha) <font size=-2><a target=_blank href="features_help.html#ch_alpha">[Help]</a></font> <td class="grey">$ch_alpha
<tr><td class="grey">Church mRNA Expression (gal) <font size=-2><a target=_blank href="features_help.html#ch_gal">[Help]</a></font> <td class="grey">$ch_gal
<tr><td class="grey">Church mRNA Expression (heat) <font size=-2><a target=_blank href="features_help.html#ch_heat">[Help]</a></font> <td class="grey">$ch_heat
<tr><td class="grey">Samson mRNA Expression <font size=-2><a target=_blank href="features_help.html#samson">[Help]</a></font> <td class="grey">$samson</tr>

<tr><td class="cap" colspan=2>Relative Expression Data</td></tr>
<tr><td class="grey"><b>Feature</b><td class="grey"><b>Value</b>
<tr><td class="grey">Cell Cycle mRNA Expr. Fluctuation (CDC15 arrest) <font size=-2><a target=_blank href="features_help.html#mrcyc15">[Help]</a></font> <td class="grey">$mrcyc15
<tr><td class="grey">Cell Cycle mRNA Expr. Fluctuation (CDC28 arrest) <font size=-2><a target=_blank href="features_help.html#mrcyc28">[Help]</a></font> <td class="grey">$mrcyc28
<tr><td class="grey">Cell Cycle mRNA Expr. Fluctuation (Alpha-factor arrest) <font size=-2><a target=_blank href="features_help.html#mrcycsd">[Help]</a></font> <td class="grey">$mrcycsd
<tr><td class="grey">Cell Cycle mRNA Expr. Fluctuation (Elutriation) <font size=-2><a target=_blank href="features_help.html#mrcyelu">[Help]</a></font> <td class="grey">$mrcyelu
<tr><td class="grey">Diauxic Shift mRNA Expr. Fluctuation <font size=-2><a target=_blank href="features_help.html#mrdiasd">[Help]</a></font> <td class="grey">$mrdiasd
</table>

<td class="back">

<table border="0" cellspacing=3 cellpadding=0>
<tr><td class="cap" colspan=2>Sequence Motifs</td></tr>
<tr><td class="grey"><b>Feature</b><td class="grey"><b>Value</b>
<tr><td class="grey">Nuclear Localization Signal 1 <font size=-2><a target=_blank href="features_help.html#nuc1">[Help]</a></font> <td class="grey">$nuc1
<tr><td class="grey">Nuclear Localization Signal 2 <font size=-2><a target=_blank href="features_help.html#nuc2">[Help]</a></font> <td class="grey">$nuc2
<tr><td class="grey">Mitochondrial Signal 1 <font size=-2><a target=_blank href="features_help.html#mit1">[Help]</a></font> <td class="grey">$mit1
<tr><td class="grey">Mitochondrial Signal 2 <font size=-2><a target=_blank href="features_help.html#mit2">[Help]</a></font> <td class="grey">$mit2
<tr><td class="grey">HDEL ER Retention Signal <font size=-2><a target=_blank href="features_help.html#hdel">[Help]</a></font> <td class="grey">$hdel
<tr><td class="grey">Plasma Membrane Signal <font size=-2><a target=_blank href="features_help.html#plmnew1">[Help]</a></font> <td class="grey">$plmnew1
<tr><td class="grey">Peroxisome Import Signal <font size=-2><a target=_blank href="features_help.html#pox1">[Help]</a></font> <td class="grey">$pox1
<tr><td class="grey">Signal Sequence (method 1) <font size=-2><a target=_blank href="features_help.html#sig1">[Help]</a></font> <td class="grey">$sig1
<tr><td class="grey">Signal Sequence (method 2) <font size=-2><a target=_blank href="features_help.html#signalp">[Help]</a></font> <td class="grey">$signalp
<tr><td class="grey">Glycosylation sites <font size=-2><a target=_blank href="features_help.html#glyc">[Help]</a></font> <td class="grey">$glyc
<tr><td class="grey">Farnesylation site <font size=-2><a target=_blank href="features_help.html#farn">[Help]</a></font> <td class="grey">$farn
<tr><td class="grey">Geranylgeranylation site <font size=-2><a target=_blank href="features_help.html#ggsi">[Help]</a></font> <td class="grey">$ggsi
<tr><td class="grey">Myristolation site <font size=-2><a target=_blank href="features_help.html#myri">[Help]</a></font> <td class="grey">$myri

HTML
if ($opt =~ /1/) {
print <<HTML;
<tr><td class="grey">Potential CDC 28 kinase sites <font size=-2><a target=_blank href="features_help.html#cdc28">[Help]</a></font> <td class="grey">$cdc28
<tr><td class="grey">Potential Casein kinase II sites <font size=-2><a target=_blank href="features_help.html#ckii">[Help]</a></font> <td class="grey">$ckii
HTML
}
print <<HTML;
<tr><td class="grey">Potential protein kinase A target sites <font size=-2><a target=_blank href="features_help.html#pka">[Help]</a></font> <td class="grey">$pka
<tr><td class="grey">Coiled Coils <font size=-2><a target=_blank href="features_help.html#coildco">[Help]</a></font> <td class="grey">$coildco
</table>
</tr>

<tr>
<td class="back">
<dd><table border="0" cellspacing=3 cellpadding=0>
<tr><td class="cap" colspan=2>Other Properties</td></tr>
<tr><td class="grey"><b>Feature</b><td class="grey"><b>Value</b>
<tr><td class="grey">Knockout Mutation <font size=-2><a target=_blank href="features_help.html#knocout">[Help]</a></font> <td class="grey">$knocout
<tr><td class="grey">Isoelectric Point <font size=-2><a target=_blank href="features_help.html#pi">[Help]</a></font> <td class="grey">$pi
<tr><td class="grey">Trans-membrane Segments <font size=-2><a target=_blank href="features_help.html#tms1">[Help]</a></font> <td class="grey">$tms1
<tr><td class="grey">Length (amino acids) <font size=-2><a target=_blank href="features_help.html#length">[Help]</a></font> <td class="grey">$length
<tr><td class="grey">Surface Amino Acid Composition Compartment <font size=-2><a target=_blank href="features_help.html#rostall">[Help]</a></font> <td class="grey">$rostall
</table>
</td></tr>
</table>
<p><br>
</body></html>

HTML

exit;


sub parse_form_data
{
  local (*FORM_DATA) = @_;
  local ($request_method, $query_string, @key_value_pairs, $key_value, $key, $value);

  $request_method = $ENV{'REQUEST_METHOD'};
  if ($request_method eq "GET") {
    $query_string = $ENV{'QUERY_STRING'};
  } elsif ($request_method eq "POST") {
    read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});     #no. of bytes to receive
  } else {
    &return_error (500, "Server Error", "Server uses unsupported method");
  }

  @pairs = split(/&/, $query_string);     #making list of keyword-value pair
  foreach $pair (@pairs)
  {
    ($key, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;              #translate "+" to space
    #decipher ASCI hexadecimal escaped characters
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    if (defined ($FORM_DATA{$key})) {
      $FORM_DATA{$key} = join ("\0", $FORM_DATA{$key}, $value);
    } else {
      $FORM_DATA{$key} = $value;
    }
  }
}

sub return_error
{
  local ($status, $keyword, $message) = @_;

  print "Content-type: text/html", "\n";
  print "Status: ", $status, " ", $keyword, "\n\n";

  print <<End_of_Error;
  
  <HTML>
  <HEAD>
    <TITLE>CGI Program - Unexpected Error</TITLE>
  </HEAD>
  <BODY>
  <H1>$keyword</H1>
  <HR>$message<HR>
  Please contact the webmaster for more information.
  </BODY>
  </HTML>

End_of_Error
  
  exit(1);
}


